/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.bausteine.voraussetzungen;

import net.n3.nanoxml.IXMLElement;
import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.basis.KonfliktBeschreibung;

/**
 * Eine Voraussetzung fuer einen Heldenbaustein, die von einem Helden
 * erfuellt werden muss wenn er den Baustein waehlen will.
 */
public interface Voraussetzung {

    /**
     * Ueberprueft ob der Held die Voraussetzung erfuellt.
     *
     * @param held fuer den die Voraussetzung geprueft werden soll.
     * @return ein Beschreibung der Probleme wenn der Held die Voraussetzung
     *      nicht erfuellt.
     */
    public KonfliktBeschreibung pruefen( final Held held );

    /**
     * @return das XML-Element, das die Voraussetzung repraesentiert.
     */
    public IXMLElement toXml();
}
