/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.gui.action;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.gui.Hauptpanel;

public abstract class ActionSpeichernHeld extends ActionSpeichern {

    ActionSpeichernHeld(
            final String nameId,
            final String icon,
            final String mnemonicId,
            final String tastenId,
            final JFrame dasHauptfenster,
            final Hauptpanel dasHauptpanel ) {

        super( nameId, icon, mnemonicId, tastenId, dasHauptfenster, dasHauptpanel );
    }


    ActionSpeichernHeld(
            final String nameId,
            final String icon,
            final String mnemonicId,
            final String tastenId,
            final JFrame dasHauptfenster,
            final Hauptpanel dasHauptpanel,
            final JFileChooser fileChooser ) {

        super( nameId, icon, mnemonicId, tastenId, dasHauptfenster,
                dasHauptpanel, fileChooser );
    }

    @Override
    String getDateinameVorschlag() {

        return getHeld().getName() + getDateierweiterung();
    }

    /**
     * @return der Held der gespeichert werden soll.
     */
    protected Held getHeld() {
        return hauptpanel.getPanelSteigern().getHeld();
    }
}
