/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.gui.action;

import java.io.File;

import javax.swing.JFrame;

import de.bernhardjung.dsaprogramm.basis.heldio.HeldExportRtf;
import de.bernhardjung.dsaprogramm.gui.Hauptpanel;
import de.bernhardjung.dsaprogramm.util.Einstellungen;

public class ActionSpeichernHeldRtf extends ActionSpeichernHeld {

    private final Einstellungen einstellungen;

    private final HeldExportRtf export;

    public ActionSpeichernHeldRtf(
            final JFrame dasHauptfenster,
            final Hauptpanel dasHauptpanel ) {
        super( "ActionSpeichernHeldRtf.Name",
               "auge",
               "ActionSpeichernHeldRtf.Mnemonic",
               "ActionSpeichernHeldRtf.Tasten",
               dasHauptfenster,
               dasHauptpanel );

        einstellungen = Einstellungen.getInstanz();

        export = new HeldExportRtf();
    }

    @Override
    String getDateierweiterung() {
        return ".rtf";
    }

    @Override
    void speichern( final File datei ) {
        export.speichern( getHeld(), datei );
    }

    @Override
    String getVerzeichnis() {
        return einstellungen.getHeldenRtfVerzeichnis();
    }

    @Override
    void setVerzeichnis( final File verzeichnis ) {

        final String pfad = verzeichnis.getAbsolutePath();

        einstellungen.setHeldenRtfVerzeichnis( pfad );
    }

}
